/*defmulist.h*/

#ifndef __defmulist_INCLUDED
#define __defmulist_INCLUDED

#define NEEDED_FOR_TENDENCY_CALC (ATM_PRESSURE|TEMP|HUMID)
/**
* sampList is the context of one of 10 availible WIT's.
* It consists of:
* timeY:	The year the sample arrived
* timeMo:	The month the sample arrived
* timeD:	The day the sample arrived
* timeH:	The hour the sample arrived
* timeM:	The minute the sample arrived
* timeS:	The second the sample arrived
* value:	The sample value.
*
*	Needed:			For:		Actual:
*	7bit			timeY		8bit
*	4bit			timeMo		8bit
*	5bit			timeD		8bit
*	5bit			timeH		8bit
*	6bit			timeM		8bit
*	6bit			timeS		8bit
*	8bit			value		8bit
*/
typedef struct sampList {
	uint8_t timeY;
	uint8_t timeMo;
	uint8_t timeD;
	uint8_t timeH;
	uint8_t timeM;
	uint8_t timeS;
	uint8_t value;
	uint8_t next;
	uint8_t prev;
} sampList;

/**
* mu is the context of one of 8 availible MU's.
* It consists of:
* witAvail:	Which types of weather information availible at this MU
* witEnabl:	Which types of weather information softly enabled at this MU
* witSampl:	The sampList lists for the availible weather information types at this MU
* address:	The address of this MU
*
*	Needed:			For:		Actual:
*	10bit			witAvail	16bit
*	10bit			witEnabl	16bit
*	10*sizeof(sampList)	witSampl	10*sizeof(sampList)
*	4bit			address		8bit
*/
typedef struct mu {
	uint16_t witAvail;
	uint16_t witEnabl;
	uint8_t witSampl[11];
	uint8_t address;
} mu;


#endif