/*.BM*******************************************************************
	Copyright (C) 1983 Intermetrics, Inc.
AUTHOR		:   David Sotkowitz
SECTION		:   C Run Time Library
MODULE		:   m/rt/c/68000/dm/stdio.h
SCCS ID		:   1.16
LAST DELTA	:   7/18/89  16:25:48
DATE OF GET	:   7/18/89  16:26:23
UNIX FILE	:   /usr2/millen/m/rt/c/68000/dm/s.stdio.h
@(#)m/rt/c/68000/dm/stdio.h	1.16

    RELATION:
	Include file for standard C I/O functions, e.g., printf.

	NOTE: this file also includes definitions for standard C string
	manipulation routines.  On Unix systems, the extern definitions
	for the string functions are found in "string.h" or "strings.h",
	depending upon whether it's Unix 4.x or Unix 5.x.
	Since there is no universal agreement on where the string functions
	go, we put them here so everyone will be sure to find them.

	This file provides definitions for standard C character type
	macros, e.g., isupper by including "ctype.h".  On Unix systems,
	the stdio.h include file does not include "ctype.h".
	This #include is provided for backwards compatibility only.

	Mathematical functions, e.g., sin, are in math.h;
	memory manipulation functions, e.g., memset, are in memory.h.

************************************************************************
.EM*/

/* include stdio.h contents only once */

#ifndef __STDIO_INCLUDED
#define __STDIO_INCLUDED


/************************************************************************

	    The following MUST be redefined by the installer !!!!

************************************************************************/

typedef int FILE;
	/* defined for illustration -- in most implementations this */
        /* is probably a structure of some sort */

/************************************************************************

  The following are environment dependent and may need  to be changed.

************************************************************************/

/* standard C defines */

#define		EOF		(-1)
#define		NULL		(0)


/* standard C external definitions */

extern void	 _exit();
extern void	 exit();
extern int	 fclose();
extern int	 fflush();
extern FILE	*fopen();
extern int	 getc();
extern char	*malloc();
extern int	 putc();
extern int	 ungetc();

    /* In this implementation, getc and putc are functions, not macros. */
    /* Hence, fgetc is the same as getc, and fputc is the same as putc. */
    /* Also, free is the same as cfree, so it is provided as a macro.   */
#define	fgetc	getc
#define	fputc	putc
#define	free	cfree

extern FILE	*stdin;
extern FILE	*stdout;
extern FILE	*stderr;

/************************************************************************

	    The following are used for text input

************************************************************************/

#define		EOL		13
#define		DEL		8

/************************************************************************

	    The following should NOT be changed !!

************************************************************************/

/* standard C defines */

#define		FALSE		0
#define		NIL		0
#define		NO		0
#define		OFF		0
#define		ON		1
#define		RESET(a)	(a = OFF)
#define		SET(a)		(a = ON)
#define		TRUE		1
#define		YES		1

/* standard C macros */

#define getchar()	getc(stdin)
#define putchar(c)	putc(c, stdout)

/* Note: the character test macros like "isupper" used to be */
/* defined here, but they are now in ctype.h.  To support    */
/* backwards compatibility, ctype.h is also included here.   */
/* In standard C this include would not be here.             *
#include "ctype.h" //Borttagen 090801/*

/* standard C external definitions */

extern char	*calloc();
extern void	 cfree();
extern char	*fgets();
extern int	 fprintf();
extern int	 fputs();
extern int	 fscanf();
extern int	 printf();
extern int	 scanf();
extern int	 sprintf();
extern int	 sscanf();
extern int	 fread();
extern int	 fwrite();
extern int	 getw();
extern long	 getl();
extern char	*gets();
extern int	 putw();
extern long	 putl();
extern int	 puts();

/* standard C string functions - also in string.h */

extern char	*index();  /* same as strchr */
extern char	*rindex(); /* same as strrchr */
extern char	*strcpy();
extern char	*strncpy();
extern char	*strcat();
extern char	*strncat();
extern char	*strchr();
extern char	*strrchr();
extern char	*strpbrk();
extern char	*strtok();
extern int	 strcmp();
extern int	 strncmp();
extern int	 strlen();
extern int	 strspn();
extern int	 strcspn();

/* this endif matches the ifndef __STDIO_INCLUDED at the start of this file */
#endif
