/*************************************************************************
*                            main.c
*                            ------
*   Detta ar huvudprogrammet som ar skrivet i ANSI C. Exekveringen av hela
*   programpaketet borjar i pmain.68k (lage __main).
*
*   exp4() anropas fran assemblyprogrammet exp4.68k vid avbrott.
*
*   _avben() anropar avben.68k vilket tillater avbrott fran PI/T.
****************************************************************************/

/**
* Includes
*/
#include "INC/stdio.h"
#include "INC/inttypes.h"
#include "INC/defines.h"

#include "INC/r_main.h"
#include "INC/defmain.h"

#include "INC/r_tmr.h"
#include "INC/deftmr.h"

#include "INC/debug.h"

#include "INC/defcom.h"

#include "INC/r_rad.h"
#include "INC/defrad.h"


/*#include "INC/defmulist.h"
#include "INC/r_MUlist.h"

#include "INC/r_delay.h"*/

/*Lnefunk*/
uint8_t rad_getreg(uint8_t reg, uint8_t* pBuff, uint8_t bytes);


char* leds = (char*)0x3C001C;

/**
* Private function declarations
*/
void init(void);

/**
* Private variables
*/
char receiverEnabled;
uint8_t tmrCntr;
uint8_t interruptIntervals[10];
uint8_t IRQ_Source;

/*extern sampList sampArray[200];*/
extern uint8_t nRF_Buffer[32];
/***********************************************************************************
* Private functions
************************************************************************************/

/**
* Main-funktionen. Exekveringen hoppar hit efter att stacken mm initierats i pmain.68k
*/
main()
{
	
	uint8_t temp,tmp,tmp1;
	init();
	tmrInit();
	spiInit();
	rad_init();
	comInit();
	muInit();
	_avben();
	RX_Mode();
	spiSetCE(1);
	

	while(1){
		*leds = 0xaa;
		for(temp=0;temp<255;temp++){
			for(tmp=0;tmp<255;tmp++)
				for(tmp1=0;tmp1<2;tmp1++);
		}
		
		rad_showconf();
		for(temp=0;temp<255;temp++){
			for(tmp=0;tmp<255;tmp++)
				for(tmp1=0;tmp1<2;tmp1++);
		}
		
		rad_showfifo();
		for(temp=0;temp<255;temp++){
			for(tmp=0;tmp<255;tmp++)
				for(tmp1=0;tmp1<2;tmp1++);
		}
		
		rad_showstat();
		for(temp=0;temp<255;temp++){
			for(tmp=0;tmp<255;tmp++)
				for(tmp1=0;tmp1<2;tmp1++);
		}
		
	}
}

/**
* Avbrottsprogram fr klockan, hgst prio genom palce.nr1...
* Hr skts exekveringen av alla isokrona uppgifterna.
*/
exp2()
{
	int i;
	uint16_t toSample = 0;
	
	if(tmrCause() == int_min){
		if(receiverEnabled){	
			/*Only go up to wind dir, after that its just history-related WIT's,
			  which are not sampled from MU's*/
			for(i = 0; i<=10; i++){
				/* counter modulus interruptInterval = 0 endast d
				   tiden r en multipel av interruptInterval.*/
				if(!(tmrCntr % interruptIntervals[i])){
					/*isokron interrupt!!!*/
					toSample |= 0x01<<i;
				}
			}
			muSampleWIT(toSample);
			muUpdateUnitList();
		}
		tmrCntr++;
	}
	return;

}

/**
* avbrottsprogram fr SPI-RADIO, ingen annan SPI-perefrial har irq ansluten.
*/
exp5()
{
	spiSetCE(0);
	rad_IRQ();
	spiSetCE(1);
	return;
}

/**
* Initiering av systemet
*/
void init()
{
	receiverEnabled = TRUE;
	/* Tider nedan bara satta p mf, kolla efter lmpliga tider
	   baserat p vad det r fr WIT. */
	interruptIntervals[TEMP] = 1;
	interruptIntervals[HUMID] = 10;
	interruptIntervals[ATM_PRESSURE] = 10;
	interruptIntervals[RAIN] = 20;
	interruptIntervals[WIND_SPEED] = 2;
	interruptIntervals[WIND_DIR] = 2;
	interruptIntervals[TENDENCY] = 30;
	interruptIntervals[HUMID_HIST] = 30;
	interruptIntervals[ATM_PRESSURE_HIST] = 30;
	interruptIntervals[TEMP_HIST] = 10;
	interruptIntervals[WIND_SPEED_HIST] = 10;
}

void setReceiverEnabled(char val){
	receiverEnabled = val;
}

char getReceiverEnabled(void){
	return receiverEnabled;
}

void setInterruptInterval(uint8_t intval, uint8_t WIT)
{
	interruptIntervals[WIT] = intval;
}

uint8_t getInterruptInterval(uint8_t WIT)
{
	return interruptIntervals[WIT];
}