/*************************************************************************
*                            tmr.c
*                            ------
*   Detta r modulen som skter realtidsklockan.
****************************************************************************/
/**
* Includes
*/
#include "INC/stdio.h"
#include "INC/inttypes.h"
#include "INC/defines.h"
#include "INC/deftmr.h"
#include "INC/debug.h"

/**
* Private function declarations
*/


/**
* Private variables
*/
static char *TMR_HUNDR	 	= (unsigned short int *)0x020000;
static char *TMR_HOUR 		= (unsigned short int *)0x020001;
static char *TMR_MIN 		= (unsigned short int *)0x020002;
static char *TMR_SEC 		= (unsigned short int *)0x020003;
static char *TMR_MONTH 	= (unsigned short int *)0x020004;
static char *TMR_DATE 		= (unsigned short int *)0x020005;
static char *TMR_YEAR 		= (unsigned short int *)0x020006;
static char *TMR_WKDAY 	= (unsigned short int *)0x020007;

static char *TMR_RHUNDR 	= (unsigned short int *)0x020008;
static char *TMR_RHOUR		= (unsigned short int *)0x020009;
static char *TMR_RMIN 		= (unsigned short int *)0x02000A;
static char *TMR_RSEC 		= (unsigned short int *)0x02000B;
static char *TMR_RMONTH 	= (unsigned short int *)0x02000C;
static char *TMR_RDATE 	= (unsigned short int *)0x02000D;
static char *TMR_RYEAR 	= (unsigned short int *)0x02000E;
static char *TMR_RWKDAY 	= (unsigned short int *)0x02000F;

static char *TMR_INTSTAT	= (unsigned short int *)0x020010;
static char *TMR_CMD 		= (unsigned short int *)0x020011;

/***********************************************************************************
* Private functions
************************************************************************************/
void tmrInit()
{
	*TMR_CMD = cmd_int | cmd_run | cmd_24h;	/*Timern, tillt interrupts, kr klockan, 24h mode|*/
	*TMR_INTSTAT = int_sec;
}

uint8_t tmrCause()
{
	return *TMR_INTSTAT;
}

uint8_t tmrGetYear()
{
	return *TMR_YEAR;
}
uint8_t tmrGetMonth()
{
	return *TMR_MONTH;
}
uint8_t tmrGetDay()
{
	return *TMR_DATE;
}
uint8_t tmrGetWeekDay()
{
	return *TMR_WKDAY;
}
uint8_t tmrGetHour()
{
	return *TMR_HOUR;
}
uint8_t tmrGetMinute()
{
	return *TMR_MIN;
}
uint8_t tmrGetSecond()
{
	return *TMR_SEC;
}
uint8_t tmrGetHundred()
{
	return *TMR_HUNDR;
}

void tmrSetYear(uint8_t time)
{
	*TMR_YEAR = time;
}
void tmrSetMonth(uint8_t time)
{
	*TMR_YEAR = time;
}
void tmrSetDay(uint8_t time)
{
	*TMR_YEAR = time;
}
void tmrSetWeekDay(uint8_t time)
{
	*TMR_YEAR = time;
}
void tmrSetHour(uint8_t time)
{
	*TMR_YEAR = time;
}
void tmrSetMinute(uint8_t time)
{
	*TMR_YEAR = time;
}
void tmrSetSecond(uint8_t time)
{
	*TMR_YEAR = time;
}
void tmrSetHundred(uint8_t time)
{
	*TMR_YEAR = time;
}