/*defcom.h*/

#ifndef __defcom_INCLUDED
#define __defcom_INCLUDED

#define STATE_IDLE	0x00
#define STATE_SEND	0x01
#define STATE_RESEND	0x02

#define MAX_RETRIES 15
#define TIMEOUT_THRESHOLD 100

#define TYPE_DU 0x00
#define TYPE_MU 0x01
#define TYPE_CU 0x02	

#define	PACK_STATUS 		0x00
#define	PACK_STATUS_REQ		0x01
#define	PACK_ACK 		0x02
#define	PACK_FIND_MU 		0x03
#define	PACK_SET_ADDR 		0x04
#define	PACK_SAMP_REQ 		0x05
#define	PACK_SAMP 		0x06
#define	PACK_STOF 		0x07
#define	PACK_HTOF 		0x08
#define	PACK_ESD 		0x09
#define	PACK_DSD 		0x0A
#define	PACK_SET_CU_TIME 	0x0B
#define	PACK_SAMP_INT	 	0x0C
#define	PACK_CLEAR_HIST 	0x0D
#define	PACK_SET_HIST_INT 	0x0E


/**
* pack is the internal data packet structure.
* It consists of:
*	Needed:		For:		Actual:
*	4bits 		to		8bits
*	4bits 		from		8bits
*	4bits 		ctrl		8bits
*	4bits 		unit		8bits
*	8bits 		length		8bits
*	8bits*length 	data		8bits*length
*
* For more information, see specification of requirements.
*/
typedef struct pack{
	uint8_t to;
	uint8_t from;
	uint8_t ctrl;
	uint8_t unit;
	uint8_t length;
	uint8_t data[32];
} pack;

#define UPPER 0xF0
#define LOWER 0x0F

#endif
