/**
* Public function declarations for commHandler.c
*/

#ifndef __r_com_INCLUDED
#define __r_com_INCLUDED

/**
* Initiates the communication handler
*/
void comInit(void);

/**
* To be run when radio throws IRQ
*/
void comReceive(void);

void comInspect(pack* pPacket);

/**
* For sending packets
*/
void comSend(pack* pPacket, uint8_t toAddr);
/**
* packetEncode encodes a pack-struct to a byte array that can be sent by the radio
*/
void comPacketEncode(pack* pPacket, uint8_t* payload);

/**
* packetEncode encodes a pack-struct to a byte array that can be sent by the radio
*/
void comPacketDecode(uint8_t* pBytes, pack* pOutPacket);

void comBuildStatus(pack* pPacket);
void comBuildStatusReq(pack* pPacket);
void comBuildAddrReq(pack* pPacket);
void comBuildSampReq(pack* pPacket, uint8_t field_mu, uint8_t field_wit);
void comBuildSample(pack* pInPacket,pack* pOutPacket);
void setMyAddr(uint8_t addr);
uint8_t getMyAddr(void);
uint8_t getValues(uint8_t WIT);
void comTest(void);
#endif
